import numpy as np
import sys
import os
import re
import h5py
#from numba import njit, prange
import time
import torch

#@njit(fastmath=True)
def calcu_mp4(num_orb, lumo, noe, int2el, device):

  e1 = 0
  ee = torch.zeros((lumo, lumo, num_orb-lumo, num_orb-lumo), device=device)

  # S
  for b in range(lumo):
    x1 =torch.einsum('kclm,lmc->cklm',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    x2 =torch.einsum('kclm,mlc->cklm',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    x3 =torch.einsum('cklm,lmc->cklm',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    x4 =torch.einsum('cklm,mlc->cklm',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    y1 = +8*x1-4*x2-4*x3+8*x4
    y2 = -4*x1+2*x2+2*x3-4*x4
    e = (noe[b]-noe[None,lumo:num_orb,None,None])*(noe[b]+noe[:lumo,None,None,None]-noe[None,None,lumo:num_orb,None]-noe[None,None,None,lumo:num_orb])
    ee[:,b,:,:] += 0.25 * (torch.einsum('ijak,cklm->aij',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],y1/e)+torch.einsum('jiak,cklm->aij',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    x9 =torch.einsum('kclm,lmc->cklm',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    x10 =torch.einsum('kclm,mlc->cklm',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    x11 =torch.einsum('cklm,lmc->cklm',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    x12 =torch.einsum('cklm,mlc->cklm',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    y1 = -4*x9+2*x10+2*x11-4*x12
    y2 = +8*x9-4*x10-4*x11+8*x12
    e = (noe[a]-noe[None,lumo:num_orb,None,None])*(noe[a]+noe[:lumo,None,None,None]-noe[None,None,lumo:num_orb,None]-noe[None,None,None,lumo:num_orb])
    ee[a,:,:,:] += 0.25 * (torch.einsum('ijbk,cklm->bij',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],y1/e)+torch.einsum('jibk,cklm->bij',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for b in range(lumo):
    x1 =torch.einsum('cdl,klcd->cdkl',int2el[:lumo,:lumo,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x2 =torch.einsum('cdl,lkcd->cdkl',int2el[:lumo,:lumo,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x3 =torch.einsum('dcl,klcd->cdkl',int2el[:lumo,:lumo,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x4 =torch.einsum('dcl,lkcd->cdkl',int2el[:lumo,:lumo,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    y1 = +8*x1-4*x2-4*x3+8*x4
    y2 = -4*x1+2*x2+2*x3-4*x4
    e = (noe[b]-noe[None,None,lumo:num_orb,None])*(noe[:lumo,None,None,None]+noe[None,:lumo,None,None]-noe[None,None,lumo:num_orb,None]-noe[None,None,None,lumo:num_orb])
    ee[:,b,:,:] += -0.25 * (torch.einsum('ijak,cdkl->aij',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],y1/e)+torch.einsum('jiak,cdkl->aij',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    x9 =torch.einsum('cdl,klcd->cdkl',int2el[:lumo,:lumo,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x10 =torch.einsum('cdl,lkcd->cdkl',int2el[:lumo,:lumo,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x11 =torch.einsum('dcl,klcd->cdkl',int2el[:lumo,:lumo,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x12 =torch.einsum('dcl,lkcd->cdkl',int2el[:lumo,:lumo,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    y1 = -4*x9+2*x10+2*x11-4*x12
    y2 = +8*x9-4*x10-4*x11+8*x12
    e = (noe[a]-noe[None,None,lumo:num_orb,None])*(noe[:lumo,None,None,None]+noe[None,:lumo,None,None]-noe[None,None,lumo:num_orb,None]-noe[None,None,None,lumo:num_orb])
    ee[a,:,:,:] += -0.25 * (torch.einsum('ijbk,cdkl->bij',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],y1/e)+torch.einsum('jibk,cdkl->bij',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for j in range(lumo,num_orb):
    x1 =torch.einsum('dkl,klcd->cdkl',int2el[j,:lumo,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x2 =torch.einsum('dkl,lkcd->cdkl',int2el[j,:lumo,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x3 =torch.einsum('dkl,klcd->cdkl',int2el[:lumo,j,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x4 =torch.einsum('dkl,lkcd->cdkl',int2el[:lumo,j,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    y1 = +8*x1-4*x2-4*x3+8*x4
    y2 = -4*x1+2*x2+2*x3-4*x4
    e = (noe[:lumo,None,None,None]-noe[j])*(noe[:lumo,None,None,None]+noe[None,:lumo,None,None]-noe[None,None,lumo:num_orb,None]-noe[None,None,None,lumo:num_orb])
    ee[:,:,:,j-lumo] += -0.25 * (torch.einsum('icab,cdkl->abi',int2el[lumo:num_orb,:lumo,:lumo,:lumo],y1/e)+torch.einsum('ciab,cdkl->abi',int2el[:lumo,lumo:num_orb,:lumo,:lumo],y2/e))

  for j in range(lumo,num_orb):
    x9 =torch.einsum('dkl,klcd->cdkl',int2el[j,:lumo,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x10 =torch.einsum('dkl,lkcd->cdkl',int2el[j,:lumo,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x11 =torch.einsum('dkl,klcd->cdkl',int2el[:lumo,j,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x12 =torch.einsum('dkl,lkcd->cdkl',int2el[:lumo,j,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    y1 = -4*x9+2*x10+2*x11-4*x12
    y2 = +8*x9-4*x10-4*x11+8*x12
    e = (noe[:lumo,None,None,None]-noe[j])*(noe[:lumo,None,None,None]+noe[None,:lumo,None,None]-noe[None,None,lumo:num_orb,None]-noe[None,None,None,lumo:num_orb])
    ee[:,:,:,j-lumo] += -0.25 * (torch.einsum('icba,cdkl->abi',int2el[lumo:num_orb,:lumo,:lumo,:lumo],y1/e)+torch.einsum('ciba,cdkl->abi',int2el[:lumo,lumo:num_orb,:lumo,:lumo],y2/e))

  for j in range(lumo,num_orb):
    x1 =torch.einsum('deck,kde->cdek',int2el[:lumo,:lumo,:lumo,lumo:num_orb],int2el[j,lumo:num_orb,:lumo,:lumo])
    x2 =torch.einsum('deck,kde->cdek',int2el[:lumo,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,j,:lumo,:lumo])
    x3 =torch.einsum('edck,kde->cdek',int2el[:lumo,:lumo,:lumo,lumo:num_orb],int2el[j,lumo:num_orb,:lumo,:lumo])
    x4 =torch.einsum('edck,kde->cdek',int2el[:lumo,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,j,:lumo,:lumo])
    y1 = +8*x1-4*x2-4*x3+8*x4
    y2 = -4*x1+2*x2+2*x3-4*x4
    e = (noe[:lumo,None,None,None]-noe[j])*(noe[None,:lumo,None,None]+noe[None,None,:lumo,None]-noe[j]-noe[None,None,None,lumo:num_orb])
    ee[:,:,:,j-lumo] += 0.25 * (torch.einsum('icab,cdek->abi',int2el[lumo:num_orb,:lumo,:lumo,:lumo],y1/e)+torch.einsum('ciab,cdek->abi',int2el[:lumo,lumo:num_orb,:lumo,:lumo],y2/e))

  for j in range(lumo,num_orb):
    x9 =torch.einsum('deck,kde->cdek',int2el[:lumo,:lumo,:lumo,lumo:num_orb],int2el[j,lumo:num_orb,:lumo,:lumo])
    x10 =torch.einsum('deck,kde->cdek',int2el[:lumo,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,j,:lumo,:lumo])
    x11 =torch.einsum('edck,kde->cdek',int2el[:lumo,:lumo,:lumo,lumo:num_orb],int2el[j,lumo:num_orb,:lumo,:lumo])
    x12 =torch.einsum('edck,kde->cdek',int2el[:lumo,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,j,:lumo,:lumo])
    y1 = -4*x9+2*x10+2*x11-4*x12
    y2 = +8*x9-4*x10-4*x11+8*x12
    e = (noe[:lumo,None,None,None]-noe[j])*(noe[None,:lumo,None,None]+noe[None,None,:lumo,None]-noe[j]-noe[None,None,None,lumo:num_orb])
    ee[:,:,:,j-lumo] += 0.25 * (torch.einsum('icba,cdek->abi',int2el[lumo:num_orb,:lumo,:lumo,:lumo],y1/e)+torch.einsum('ciba,cdek->abi',int2el[:lumo,lumo:num_orb,:lumo,:lumo],y2/e))

  # D
  for a in range(lumo):
    for b in range(lumo):
      x1 =torch.einsum('klmn,mn->klmn',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,b])
      x2 =torch.einsum('klmn,nm->klmn',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,b])
      x3 =torch.einsum('lkmn,mn->klmn',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,b])
      x4 =torch.einsum('lkmn,nm->klmn',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,b])
      y1 = +4*x1-2*x2-2*x3+4*x4
      y2 = -2*x1+4*x2+4*x3-2*x4
      e = (noe[b]+noe[a]-noe[None,lumo:num_orb,None,None]-noe[lumo:num_orb,None,None,None])*(noe[b]+noe[a]-noe[None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None])
      ee[a,b,:,:] += 0.0625 * (torch.einsum('ijkl,klmn->ij',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('jikl,klmn->ij',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x9 =torch.einsum('klmn,mn->klmn',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,a])
      x10 =torch.einsum('klmn,nm->klmn',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,a])
      x11 =torch.einsum('lkmn,mn->klmn',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,a])
      x12 =torch.einsum('lkmn,nm->klmn',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,a])
      y1 = -2*x9+4*x10+4*x11-2*x12
      y2 = +4*x9-2*x10-2*x11+4*x12
      e = (noe[a]+noe[b]-noe[None,lumo:num_orb,None,None]-noe[lumo:num_orb,None,None,None])*(noe[a]+noe[b]-noe[None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None])
      ee[a,b,:,:] += 0.0625 * (torch.einsum('ijkl,klmn->ij',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('jikl,klmn->ij',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x1 =torch.einsum('kcm,lmc->cklm',int2el[lumo:num_orb,:lumo,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x2 =torch.einsum('kcm,mlc->cklm',int2el[lumo:num_orb,:lumo,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x3 =torch.einsum('ckm,lmc->cklm',int2el[:lumo,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x4 =torch.einsum('ckm,mlc->cklm',int2el[:lumo,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      y1 = +8*x1-4*x2-4*x3+2*x4
      y2 = -4*x1+2*x2+2*x3-4*x4
      e = (noe[b]+noe[a]-noe[None,None,lumo:num_orb,None]-noe[None,lumo:num_orb,None,None])*(noe[:lumo,None,None,None]+noe[b]-noe[None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None])
      ee[a,b,:,:] += 0.5 * (torch.einsum('ijkl,cklm->ij',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('jikl,cklm->ij',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x9 =torch.einsum('kcm,lmc->cklm',int2el[lumo:num_orb,:lumo,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x10 =torch.einsum('kcm,mlc->cklm',int2el[lumo:num_orb,:lumo,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x11 =torch.einsum('ckm,lmc->cklm',int2el[:lumo,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x12 =torch.einsum('ckm,mlc->cklm',int2el[:lumo,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      y1 = -4*x9+2*x10+2*x11-4*x12
      y2 = +8*x9-4*x10-4*x11+2*x12
      e = (noe[a]+noe[b]-noe[None,None,lumo:num_orb,None]-noe[None,lumo:num_orb,None,None])*(noe[:lumo,None,None,None]+noe[a]-noe[None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None])
      ee[a,b,:,:] += 0.5 * (torch.einsum('ijkl,cklm->ij',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('jikl,cklm->ij',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x1 =torch.einsum('cd,klcd->cdkl',int2el[:lumo,:lumo,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x2 =torch.einsum('cd,lkcd->cdkl',int2el[:lumo,:lumo,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x3 =torch.einsum('dc,klcd->cdkl',int2el[:lumo,:lumo,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x4 =torch.einsum('dc,lkcd->cdkl',int2el[:lumo,:lumo,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      y1 = +4*x1-2*x2-2*x3+4*x4
      y2 = -2*x1+4*x2+4*x3-2*x4
      e = (noe[b]+noe[a]-noe[None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None])*(noe[None,:lumo,None,None]+noe[:lumo,None,None,None]-noe[None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None])
      ee[a,b,:,:] += 0.0625 * (torch.einsum('ijkl,cdkl->ij',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('jikl,cdkl->ij',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x9 =torch.einsum('cd,klcd->cdkl',int2el[:lumo,:lumo,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x10 =torch.einsum('cd,lkcd->cdkl',int2el[:lumo,:lumo,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x11 =torch.einsum('dc,klcd->cdkl',int2el[:lumo,:lumo,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x12 =torch.einsum('dc,lkcd->cdkl',int2el[:lumo,:lumo,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      y1 = -2*x9+4*x10+4*x11-2*x12
      y2 = +4*x9-2*x10-2*x11+4*x12
      e = (noe[a]+noe[b]-noe[None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None])*(noe[None,:lumo,None,None]+noe[:lumo,None,None,None]-noe[None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None])
      ee[a,b,:,:] += 0.0625 * (torch.einsum('ijkl,cdkl->ij',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('jikl,cdkl->ij',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for b in range(lumo):
    x1 =torch.einsum('jklm,lmc->cjklm',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    x2 =torch.einsum('jklm,mlc->cjklm',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    x3 =torch.einsum('kjlm,lmc->cjklm',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    x4 =torch.einsum('kjlm,mlc->cjklm',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    y1 = +8*x1-4*x2-4*x3+8*x4
    y2 = -4*x1+2*x2+2*x3-4*x4
    e = (noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,lumo:num_orb,None,None]-noe[None,lumo:num_orb,None,None,None])*(noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
    ee[:,b,:,:] += 0.5 * (torch.einsum('icak,cjklm->aij',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('ciak,cjklm->aij',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    x9 =torch.einsum('jklm,lmc->cjklm',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    x10 =torch.einsum('jklm,mlc->cjklm',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    x11 =torch.einsum('kjlm,lmc->cjklm',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    x12 =torch.einsum('kjlm,mlc->cjklm',int2el[lumo:num_orb,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    y1 = -4*x9+2*x10+2*x11-4*x12
    y2 = +2*x9-4*x10-4*x11+2*x12
    e = (noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,lumo:num_orb,None,None]-noe[None,lumo:num_orb,None,None,None])*(noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
    ee[a,:,:,:] += 0.5 * (torch.einsum('icbk,cjklm->bij',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('cibk,cjklm->bij',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for b in range(lumo):
    x1 =torch.einsum('kdcl,jld->cdjkl',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    x2 =torch.einsum('kdcl,ljd->cdjkl',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    x3 =torch.einsum('dkcl,jld->cdjkl',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    x4 =torch.einsum('dkcl,ljd->cdjkl',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    y1 = +16*x1-8*x2-8*x3+4*x4
    y2 = -8*x1+4*x2+4*x3-2*x4
    e = (noe[b]+noe[:lumo,None,None,None,None]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None])*(noe[None,:lumo,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
    ee[:,b,:,:] += 1.0 * (torch.einsum('icak,cdjkl->aij',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('ciak,cdjkl->aij',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    x9 =torch.einsum('kdcl,jld->cdjkl',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    x10 =torch.einsum('kdcl,ljd->cdjkl',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    x11 =torch.einsum('dkcl,jld->cdjkl',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    x12 =torch.einsum('dkcl,ljd->cdjkl',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    y1 = -8*x9+4*x10+4*x11-2*x12
    y2 = +4*x9-2*x10-2*x11+4*x12
    e = (noe[a]+noe[:lumo,None,None,None,None]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None])*(noe[None,:lumo,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
    ee[a,:,:,:] += 1.0 * (torch.einsum('icbk,cdjkl->bij',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('cibk,cdjkl->bij',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for b in range(lumo):
    x1 =torch.einsum('jdcl,kld->cdjkl',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    x2 =torch.einsum('jdcl,lkd->cdjkl',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    x3 =torch.einsum('djcl,kld->cdjkl',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    x4 =torch.einsum('djcl,lkd->cdjkl',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
    y1 = +8*x1-4*x2-4*x3+8*x4
    y2 = -4*x1+2*x2+2*x3-4*x4
    e = (noe[b]+noe[:lumo,None,None,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None])*(noe[None,:lumo,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
    ee[:,b,:,:] += -1.0 * (torch.einsum('icak,cdjkl->aij',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('ciak,cdjkl->aij',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    x9 =torch.einsum('jdcl,kld->cdjkl',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    x10 =torch.einsum('jdcl,lkd->cdjkl',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    x11 =torch.einsum('djcl,kld->cdjkl',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    x12 =torch.einsum('djcl,lkd->cdjkl',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
    y1 = -4*x9+2*x10+2*x11-4*x12
    y2 = +8*x9-4*x10-4*x11+2*x12
    e = (noe[a]+noe[:lumo,None,None,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None])*(noe[None,:lumo,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
    ee[a,:,:,:] += -1.0 * (torch.einsum('icbk,cdjkl->bij',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('cibk,cdjkl->bij',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for b in range(lumo):
    x1 =torch.einsum('kdl,jlcd->cdjkl',int2el[lumo:num_orb,:lumo,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x2 =torch.einsum('kdl,ljcd->cdjkl',int2el[lumo:num_orb,:lumo,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x3 =torch.einsum('dkl,jlcd->cdjkl',int2el[:lumo,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x4 =torch.einsum('dkl,ljcd->cdjkl',int2el[:lumo,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    y1 = +8*x1-4*x2-4*x3+8*x4
    y2 = -4*x1+2*x2+2*x3-4*x4
    e = (noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
    ee[:,b,:,:] += -1.0 * (torch.einsum('icak,cdjkl->aij',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('ciak,cdjkl->aij',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    x9 =torch.einsum('kdl,jlcd->cdjkl',int2el[lumo:num_orb,:lumo,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x10 =torch.einsum('kdl,ljcd->cdjkl',int2el[lumo:num_orb,:lumo,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x11 =torch.einsum('dkl,jlcd->cdjkl',int2el[:lumo,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x12 =torch.einsum('dkl,ljcd->cdjkl',int2el[:lumo,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    y1 = -4*x9+2*x10+2*x11-4*x12
    y2 = +8*x9-4*x10-4*x11+2*x12
    e = (noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
    ee[a,:,:,:] += -1.0 * (torch.einsum('icbk,cdjkl->bij',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('cibk,cdjkl->bij',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for b in range(lumo):
    x1 =torch.einsum('jdl,klcd->cdjkl',int2el[lumo:num_orb,:lumo,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x2 =torch.einsum('jdl,lkcd->cdjkl',int2el[lumo:num_orb,:lumo,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x3 =torch.einsum('djl,klcd->cdjkl',int2el[:lumo,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x4 =torch.einsum('djl,lkcd->cdjkl',int2el[:lumo,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    y1 = +16*x1-8*x2-8*x3+4*x4
    y2 = -8*x1+4*x2+4*x3-2*x4
    e = (noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
    ee[:,b,:,:] += 1.0 * (torch.einsum('icak,cdjkl->aij',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('ciak,cdjkl->aij',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    x9 =torch.einsum('jdl,klcd->cdjkl',int2el[lumo:num_orb,:lumo,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x10 =torch.einsum('jdl,lkcd->cdjkl',int2el[lumo:num_orb,:lumo,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x11 =torch.einsum('djl,klcd->cdjkl',int2el[:lumo,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x12 =torch.einsum('djl,lkcd->cdjkl',int2el[:lumo,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    y1 = -8*x9+4*x10+4*x11-2*x12
    y2 = +4*x9-2*x10-2*x11+4*x12
    e = (noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
    ee[a,:,:,:] += 1.0 * (torch.einsum('icbk,cdjkl->bij',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('cibk,cdjkl->bij',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for b in range(lumo):
    x1 =torch.einsum('dec,jkde->cdejk',int2el[:lumo,:lumo,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x2 =torch.einsum('dec,kjde->cdejk',int2el[:lumo,:lumo,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x3 =torch.einsum('edc,jkde->cdejk',int2el[:lumo,:lumo,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x4 =torch.einsum('edc,kjde->cdejk',int2el[:lumo,:lumo,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    y1 = +8*x1-4*x2-4*x3+8*x4
    y2 = -4*x1+2*x2+2*x3-4*x4
    e = (noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])*(noe[None,None,:lumo,None,None]+noe[None,:lumo,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
    ee[:,b,:,:] += 0.5 * (torch.einsum('icak,cdejk->aij',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('ciak,cdejk->aij',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    x9 =torch.einsum('dec,jkde->cdejk',int2el[:lumo,:lumo,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x10 =torch.einsum('dec,kjde->cdejk',int2el[:lumo,:lumo,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x11 =torch.einsum('edc,jkde->cdejk',int2el[:lumo,:lumo,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x12 =torch.einsum('edc,kjde->cdejk',int2el[:lumo,:lumo,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    y1 = -4*x9+2*x10+2*x11-4*x12
    y2 = +2*x9-4*x10-4*x11+2*x12
    e = (noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])*(noe[None,None,:lumo,None,None]+noe[None,:lumo,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
    ee[a,:,:,:] += 0.5 * (torch.einsum('icbk,cdejk->bij',int2el[lumo:num_orb,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('cibk,cdejk->bij',int2el[:lumo,lumo:num_orb,:lumo,lumo:num_orb],y2/e))

  for i in range(lumo,num_orb):
    x1 =torch.einsum('jkl,klcd->cdjkl',int2el[i,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x2 =torch.einsum('jkl,lkcd->cdjkl',int2el[i,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x3 =torch.einsum('jkl,klcd->cdjkl',int2el[lumo:num_orb,i,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x4 =torch.einsum('jkl,lkcd->cdjkl',int2el[lumo:num_orb,i,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    y1 = +4*x1-2*x2-2*x3+4*x4
    y2 = -2*x1+4*x2+4*x3-2*x4
    e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,lumo:num_orb,None,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
    ee[:,:,i-lumo,:] += 0.0625 * (torch.einsum('cdab,cdjkl->abj',int2el[:lumo,:lumo,:lumo,:lumo],y1/e)+torch.einsum('dcab,cdjkl->abj',int2el[:lumo,:lumo,:lumo,:lumo],y2/e))

  for i in range(lumo,num_orb):
    x9 =torch.einsum('jkl,klcd->cdjkl',int2el[i,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x10 =torch.einsum('jkl,lkcd->cdjkl',int2el[i,lumo:num_orb,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x11 =torch.einsum('jkl,klcd->cdjkl',int2el[lumo:num_orb,i,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x12 =torch.einsum('jkl,lkcd->cdjkl',int2el[lumo:num_orb,i,lumo:num_orb,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    y1 = -2*x9+4*x10+4*x11-2*x12
    y2 = +4*x9-2*x10-2*x11+4*x12
    e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,lumo:num_orb,None,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
    ee[:,:,i-lumo,:] += 0.0625 * (torch.einsum('cdba,cdjkl->abj',int2el[:lumo,:lumo,:lumo,:lumo],y1/e)+torch.einsum('dcba,cdjkl->abj',int2el[:lumo,:lumo,:lumo,:lumo],y2/e))

  for i in range(lumo,num_orb):
    x1 =torch.einsum('eck,jkde->cdejk',int2el[i,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x2 =torch.einsum('eck,kjde->cdejk',int2el[i,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x3 =torch.einsum('eck,jkde->cdejk',int2el[:lumo,i,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x4 =torch.einsum('eck,kjde->cdejk',int2el[:lumo,i,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    y1 = +8*x1-4*x2-4*x3+2*x4
    y2 = -4*x1+2*x2+2*x3-4*x4
    e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[None,None,:lumo,None,None]+noe[None,:lumo,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
    ee[:,:,i-lumo,:] += 0.5 * (torch.einsum('cdab,cdejk->abj',int2el[:lumo,:lumo,:lumo,:lumo],y1/e)+torch.einsum('dcab,cdejk->abj',int2el[:lumo,:lumo,:lumo,:lumo],y2/e))

  for i in range(lumo,num_orb):
    x9 =torch.einsum('eck,jkde->cdejk',int2el[i,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x10 =torch.einsum('eck,kjde->cdejk',int2el[i,:lumo,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x11 =torch.einsum('eck,jkde->cdejk',int2el[:lumo,i,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    x12 =torch.einsum('eck,kjde->cdejk',int2el[:lumo,i,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
    y1 = -4*x9+2*x10+2*x11-4*x12
    y2 = +8*x9-4*x10-4*x11+2*x12
    e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[None,None,:lumo,None,None]+noe[None,:lumo,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
    ee[:,:,i-lumo,:] += 0.5 * (torch.einsum('cdba,cdejk->abj',int2el[:lumo,:lumo,:lumo,:lumo],y1/e)+torch.einsum('dcba,cdejk->abj',int2el[:lumo,:lumo,:lumo,:lumo],y2/e))

  for i in range(lumo,num_orb):
    x1 =torch.einsum('efcd,jef->cdefj',int2el[:lumo,:lumo,:lumo,:lumo],int2el[i,lumo:num_orb,:lumo,:lumo])
    x2 =torch.einsum('efcd,jef->cdefj',int2el[:lumo,:lumo,:lumo,:lumo],int2el[lumo:num_orb,i,:lumo,:lumo])
    x3 =torch.einsum('fecd,jef->cdefj',int2el[:lumo,:lumo,:lumo,:lumo],int2el[i,lumo:num_orb,:lumo,:lumo])
    x4 =torch.einsum('fecd,jef->cdefj',int2el[:lumo,:lumo,:lumo,:lumo],int2el[lumo:num_orb,i,:lumo,:lumo])
    y1 = +4*x1-2*x2-2*x3+4*x4
    y2 = -2*x1+4*x2+4*x3-2*x4
    e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[i])*(noe[None,None,None,:lumo,None]+noe[None,None,:lumo,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[i])
    ee[:,:,i-lumo,:] += 0.0625 * (torch.einsum('cdab,cdefj->abj',int2el[:lumo,:lumo,:lumo,:lumo],y1/e)+torch.einsum('dcab,cdefj->abj',int2el[:lumo,:lumo,:lumo,:lumo],y2/e))

  for i in range(lumo,num_orb):
    x9 =torch.einsum('efcd,jef->cdefj',int2el[:lumo,:lumo,:lumo,:lumo],int2el[i,lumo:num_orb,:lumo,:lumo])
    x10 =torch.einsum('efcd,jef->cdefj',int2el[:lumo,:lumo,:lumo,:lumo],int2el[lumo:num_orb,i,:lumo,:lumo])
    x11 =torch.einsum('fecd,jef->cdefj',int2el[:lumo,:lumo,:lumo,:lumo],int2el[i,lumo:num_orb,:lumo,:lumo])
    x12 =torch.einsum('fecd,jef->cdefj',int2el[:lumo,:lumo,:lumo,:lumo],int2el[lumo:num_orb,i,:lumo,:lumo])
    y1 = -2*x9+4*x10+4*x11-2*x12
    y2 = +4*x9-2*x10-2*x11+4*x12
    e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[i])*(noe[None,None,None,:lumo,None]+noe[None,None,:lumo,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[i])
    ee[:,:,i-lumo,:] += 0.0625 * (torch.einsum('cdba,cdefj->abj',int2el[:lumo,:lumo,:lumo,:lumo],y1/e)+torch.einsum('dcba,cdefj->abj',int2el[:lumo,:lumo,:lumo,:lumo],y2/e))

  
  # T
  for a in range(lumo):
    for b in range(lumo):
      x1 =torch.einsum('lkcm,jm->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,b])
      x2 =torch.einsum('lkcm,mj->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,b])
      x3 =torch.einsum('klcm,jm->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,b])
      x4 =torch.einsum('klcm,mj->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,b])
      y1 = +2*x1-4*x2-4*x3+8*x4
      y2 = -4*x1+8*x2+2*x3-4*x4
      e = (noe[b]+noe[a]+noe[:lumo,None,None,None,None]-noe[None,lumo:num_orb,None,None,None]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None])*(noe[b]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,lumo:num_orb,None,None,None])
      ee[a,b,:,:] += 0.25 * (torch.einsum('iclk,cjklm->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cilk,cjklm->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x9 =torch.einsum('lkcm,jm->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,a])
      x10 =torch.einsum('lkcm,mj->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,a])
      x11 =torch.einsum('klcm,jm->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,a])
      x12 =torch.einsum('klcm,mj->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,a])
      y1 = -4*x9+2*x10+8*x11-4*x12
      y2 = +8*x9-4*x10-4*x11+2*x12
      e = (noe[a]+noe[b]+noe[:lumo,None,None,None,None]-noe[None,lumo:num_orb,None,None,None]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None])*(noe[a]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,lumo:num_orb,None,None,None])
      ee[a,b,:,:] += 0.25 * (torch.einsum('iclk,cjklm->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cilk,cjklm->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x1 =torch.einsum('jkcm,lm->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,b])
      x2 =torch.einsum('jkcm,ml->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,b])
      x3 =torch.einsum('kjcm,lm->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,b])
      x4 =torch.einsum('kjcm,ml->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,b])
      y1 = +2*x1-4*x2-4*x3+2*x4
      y2 = -4*x1+2*x2+8*x3-4*x4
      e = (noe[b]+noe[a]+noe[:lumo,None,None,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None]-noe[None,lumo:num_orb,None,None,None])*(noe[b]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[a,b,:,:] += 0.5 * (torch.einsum('ickl,cjklm->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cikl,cjklm->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x9 =torch.einsum('jkcm,lm->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,a])
      x10 =torch.einsum('jkcm,ml->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,a])
      x11 =torch.einsum('kjcm,lm->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,a])
      x12 =torch.einsum('kjcm,ml->cjklm',int2el[lumo:num_orb,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,a])
      y1 = -4*x9+2*x10+2*x11-4*x12
      y2 = +2*x9-4*x10-4*x11+8*x12
      e = (noe[a]+noe[b]+noe[:lumo,None,None,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None]-noe[None,lumo:num_orb,None,None,None])*(noe[a]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[a,b,:,:] += 0.5 * (torch.einsum('ickl,cjklm->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cikl,cjklm->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x1 =torch.einsum('lkm,jmc->cjklm',int2el[lumo:num_orb,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x2 =torch.einsum('lkm,mjc->cjklm',int2el[lumo:num_orb,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x3 =torch.einsum('klm,jmc->cjklm',int2el[lumo:num_orb,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x4 =torch.einsum('klm,mjc->cjklm',int2el[lumo:num_orb,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      y1 = +8*x1-4*x2-4*x3+2*x4
      y2 = -4*x1+2*x2+8*x3-4*x4
      e = (noe[:lumo,None,None,None,None]+noe[b]+noe[a]-noe[None,lumo:num_orb,None,None,None]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None])*(noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,lumo:num_orb,None,None,None])
      ee[a,b,:,:] += 0.5 * (torch.einsum('iclk,cjklm->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cilk,cjklm->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x9 =torch.einsum('lkm,jmc->cjklm',int2el[lumo:num_orb,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x10 =torch.einsum('lkm,mjc->cjklm',int2el[lumo:num_orb,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x11 =torch.einsum('klm,jmc->cjklm',int2el[lumo:num_orb,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x12 =torch.einsum('klm,mjc->cjklm',int2el[lumo:num_orb,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      y1 = -4*x9+2*x10+2*x11-4*x12
      y2 = +2*x9-4*x10-4*x11+2*x12
      e = (noe[:lumo,None,None,None,None]+noe[a]+noe[b]-noe[None,lumo:num_orb,None,None,None]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None])*(noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,lumo:num_orb,None,None,None])
      ee[a,b,:,:] += 0.5 * (torch.einsum('iclk,cjklm->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cilk,cjklm->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x1 =torch.einsum('jkm,lmc->cjklm',int2el[lumo:num_orb,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x2 =torch.einsum('jkm,mlc->cjklm',int2el[lumo:num_orb,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x3 =torch.einsum('kjm,lmc->cjklm',int2el[lumo:num_orb,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x4 =torch.einsum('kjm,mlc->cjklm',int2el[lumo:num_orb,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      y1 = +2*x1-4*x2-4*x3+8*x4
      y2 = -4*x1+2*x2+2*x3-4*x4
      e = (noe[:lumo,None,None,None,None]+noe[b]+noe[a]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None]-noe[None,lumo:num_orb,None,None,None])*(noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[a,b,:,:] += 1.0 * (torch.einsum('ickl,cjklm->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cikl,cjklm->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x9 =torch.einsum('jkm,lmc->cjklm',int2el[lumo:num_orb,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x10 =torch.einsum('jkm,mlc->cjklm',int2el[lumo:num_orb,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x11 =torch.einsum('kjm,lmc->cjklm',int2el[lumo:num_orb,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x12 =torch.einsum('kjm,mlc->cjklm',int2el[lumo:num_orb,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      y1 = -4*x9+8*x10+2*x11-4*x12
      y2 = +8*x9-4*x10-4*x11+2*x12
      e = (noe[:lumo,None,None,None,None]+noe[a]+noe[b]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None]-noe[None,lumo:num_orb,None,None,None])*(noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[a,b,:,:] += 1.0 * (torch.einsum('ickl,cjklm->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cikl,cjklm->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x1 =torch.einsum('kdc,jld->cdjkl',int2el[lumo:num_orb,:lumo,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x2 =torch.einsum('kdc,ljd->cdjkl',int2el[lumo:num_orb,:lumo,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x3 =torch.einsum('dkc,jld->cdjkl',int2el[:lumo,lumo:num_orb,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x4 =torch.einsum('dkc,ljd->cdjkl',int2el[:lumo,lumo:num_orb,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      y1 = +8*x1-4*x2-4*x3+2*x4
      y2 = -4*x1+2*x2+8*x3-4*x4
      e = (noe[b]+noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None])*(noe[None,:lumo,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
      ee[a,b,:,:] += -1.0 * (torch.einsum('ickl,cdjkl->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cikl,cdjkl->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x9 =torch.einsum('kdc,jld->cdjkl',int2el[lumo:num_orb,:lumo,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x10 =torch.einsum('kdc,ljd->cdjkl',int2el[lumo:num_orb,:lumo,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x11 =torch.einsum('dkc,jld->cdjkl',int2el[:lumo,lumo:num_orb,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x12 =torch.einsum('dkc,ljd->cdjkl',int2el[:lumo,lumo:num_orb,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      y1 = -4*x9+2*x10+2*x11-4*x12
      y2 = +2*x9-4*x10-4*x11+8*x12
      e = (noe[a]+noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None])*(noe[None,:lumo,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
      ee[a,b,:,:] += -1.0 * (torch.einsum('ickl,cdjkl->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cikl,cdjkl->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x1 =torch.einsum('jdc,kld->cdjkl',int2el[lumo:num_orb,:lumo,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x2 =torch.einsum('jdc,lkd->cdjkl',int2el[lumo:num_orb,:lumo,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x3 =torch.einsum('djc,kld->cdjkl',int2el[:lumo,lumo:num_orb,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x4 =torch.einsum('djc,lkd->cdjkl',int2el[:lumo,lumo:num_orb,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      y1 = +4*x1-2*x2-2*x3+4*x4
      y2 = -2*x1+4*x2+4*x3-2*x4
      e = (noe[b]+noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None])*(noe[None,:lumo,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[a,b,:,:] += 0.5 * (torch.einsum('ickl,cdjkl->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cikl,cdjkl->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x9 =torch.einsum('jdc,kld->cdjkl',int2el[lumo:num_orb,:lumo,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x10 =torch.einsum('jdc,lkd->cdjkl',int2el[lumo:num_orb,:lumo,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x11 =torch.einsum('djc,kld->cdjkl',int2el[:lumo,lumo:num_orb,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x12 =torch.einsum('djc,lkd->cdjkl',int2el[:lumo,lumo:num_orb,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      y1 = -8*x9+4*x10+4*x11-2*x12
      y2 = +4*x9-8*x10-2*x11+4*x12
      e = (noe[a]+noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None])*(noe[None,:lumo,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[a,b,:,:] += 0.5 * (torch.einsum('ickl,cdjkl->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cikl,cdjkl->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x1 =torch.einsum('kd,jlcd->cdjkl',int2el[lumo:num_orb,:lumo,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x2 =torch.einsum('kd,ljcd->cdjkl',int2el[lumo:num_orb,:lumo,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x3 =torch.einsum('dk,jlcd->cdjkl',int2el[:lumo,lumo:num_orb,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x4 =torch.einsum('dk,ljcd->cdjkl',int2el[:lumo,lumo:num_orb,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      y1 = +4*x1-8*x2-2*x3+4*x4
      y2 = -2*x1+4*x2+4*x3-2*x4
      e = (noe[:lumo,None,None,None,None]+noe[b]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
      ee[a,b,:,:] += 0.5 * (torch.einsum('ickl,cdjkl->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cikl,cdjkl->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x9 =torch.einsum('kd,jlcd->cdjkl',int2el[lumo:num_orb,:lumo,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x10 =torch.einsum('kd,ljcd->cdjkl',int2el[lumo:num_orb,:lumo,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x11 =torch.einsum('dk,jlcd->cdjkl',int2el[:lumo,lumo:num_orb,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x12 =torch.einsum('dk,ljcd->cdjkl',int2el[:lumo,lumo:num_orb,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      y1 = -2*x9+4*x10+4*x11-8*x12
      y2 = +4*x9-2*x10-2*x11+4*x12
      e = (noe[:lumo,None,None,None,None]+noe[a]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
      ee[a,b,:,:] += 0.5 * (torch.einsum('ickl,cdjkl->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cikl,cdjkl->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x1 =torch.einsum('jd,klcd->cdjkl',int2el[lumo:num_orb,:lumo,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x2 =torch.einsum('jd,lkcd->cdjkl',int2el[lumo:num_orb,:lumo,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x3 =torch.einsum('dj,klcd->cdjkl',int2el[:lumo,lumo:num_orb,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x4 =torch.einsum('dj,lkcd->cdjkl',int2el[:lumo,lumo:num_orb,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      y1 = +2*x1-4*x2-4*x3+8*x4
      y2 = -4*x1+2*x2+8*x3-4*x4
      e = (noe[:lumo,None,None,None,None]+noe[b]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[a,b,:,:] += -0.25 * (torch.einsum('ickl,cdjkl->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cikl,cdjkl->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      x9 =torch.einsum('jd,klcd->cdjkl',int2el[lumo:num_orb,:lumo,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x10 =torch.einsum('jd,lkcd->cdjkl',int2el[lumo:num_orb,:lumo,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x11 =torch.einsum('dj,klcd->cdjkl',int2el[:lumo,lumo:num_orb,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x12 =torch.einsum('dj,lkcd->cdjkl',int2el[:lumo,lumo:num_orb,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      y1 = -4*x9+8*x10+2*x11-4*x12
      y2 = +8*x9-4*x10-4*x11+2*x12
      e = (noe[:lumo,None,None,None,None]+noe[a]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[a,b,:,:] += -0.25 * (torch.einsum('ickl,cdjkl->ij',int2el[lumo:num_orb,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('cikl,cdjkl->ij',int2el[:lumo,lumo:num_orb,lumo:num_orb,lumo:num_orb],y2/e))

  for b in range(lumo):
    for i in range(lumo,num_orb):
      x1 =torch.einsum('kcl,jld->cdjkl',int2el[i,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x2 =torch.einsum('kcl,ljd->cdjkl',int2el[i,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x3 =torch.einsum('kcl,jld->cdjkl',int2el[lumo:num_orb,i,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x4 =torch.einsum('kcl,ljd->cdjkl',int2el[lumo:num_orb,i,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      y1 = +8*x1-4*x2-4*x3+2*x4
      y2 = -4*x1+2*x2+8*x3-4*x4
      e = (noe[None,:lumo,None,None,None]+noe[b]+noe[:lumo,None,None,None,None]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
      ee[:,b,i-lumo,:] += -1.0 * (torch.einsum('cdak,cdjkl->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcak,cdjkl->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    for i in range(lumo,num_orb):
      x9 =torch.einsum('kcl,jld->cdjkl',int2el[i,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x10 =torch.einsum('kcl,ljd->cdjkl',int2el[i,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x11 =torch.einsum('kcl,jld->cdjkl',int2el[lumo:num_orb,i,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x12 =torch.einsum('kcl,ljd->cdjkl',int2el[lumo:num_orb,i,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      y1 = -4*x9+2*x10+2*x11-4*x12
      y2 = +2*x9-4*x10-4*x11+8*x12
      e = (noe[None,:lumo,None,None,None]+noe[a]+noe[:lumo,None,None,None,None]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
      ee[a,:,i-lumo,:] += -1.0 * (torch.einsum('cdbk,cdjkl->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcbk,cdjkl->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))

  for b in range(lumo):
    for i in range(lumo,num_orb):
      x1 =torch.einsum('jcl,kld->cdjkl',int2el[i,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x2 =torch.einsum('jcl,lkd->cdjkl',int2el[i,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x3 =torch.einsum('jcl,kld->cdjkl',int2el[lumo:num_orb,i,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x4 =torch.einsum('jcl,lkd->cdjkl',int2el[lumo:num_orb,i,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      y1 = +4*x1-8*x2-2*x3+4*x4
      y2 = -2*x1+4*x2+4*x3-2*x4
      e = (noe[None,:lumo,None,None,None]+noe[b]+noe[:lumo,None,None,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[:,b,i-lumo,:] += 0.5 * (torch.einsum('cdak,cdjkl->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcak,cdjkl->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    for i in range(lumo,num_orb):
      x9 =torch.einsum('jcl,kld->cdjkl',int2el[i,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x10 =torch.einsum('jcl,lkd->cdjkl',int2el[i,lumo:num_orb,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x11 =torch.einsum('jcl,kld->cdjkl',int2el[lumo:num_orb,i,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x12 =torch.einsum('jcl,lkd->cdjkl',int2el[lumo:num_orb,i,:lumo,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      y1 = -2*x9+4*x10+4*x11-8*x12
      y2 = +4*x9-2*x10-2*x11+4*x12
      e = (noe[None,:lumo,None,None,None]+noe[a]+noe[:lumo,None,None,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[a,:,i-lumo,:] += 0.5 * (torch.einsum('cdbk,cdjkl->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcbk,cdjkl->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))

  for b in range(lumo):
    for i in range(lumo,num_orb):
      x1 =torch.einsum('kecd,je->cdejk',int2el[lumo:num_orb,:lumo,:lumo,:lumo],int2el[i,lumo:num_orb,b,:lumo])
      x2 =torch.einsum('kecd,je->cdejk',int2el[lumo:num_orb,:lumo,:lumo,:lumo],int2el[lumo:num_orb,i,b,:lumo])
      x3 =torch.einsum('ekcd,je->cdejk',int2el[:lumo,lumo:num_orb,:lumo,:lumo],int2el[i,lumo:num_orb,b,:lumo])
      x4 =torch.einsum('ekcd,je->cdejk',int2el[:lumo,lumo:num_orb,:lumo,:lumo],int2el[lumo:num_orb,i,b,:lumo])
      y1 = +2*x1-4*x2-4*x3+8*x4
      y2 = -4*x1+8*x2+2*x3-4*x4
      e = (noe[b]+noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i]-noe[None,None,None,None,lumo:num_orb])*(noe[None,None,:lumo,None,None]+noe[b]-noe[None,None,None,lumo:num_orb,None]-noe[i])
      ee[:,b,i-lumo,:] += 0.25 * (torch.einsum('cdak,cdejk->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcak,cdejk->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    for i in range(lumo,num_orb):
      x9 =torch.einsum('kecd,je->cdejk',int2el[lumo:num_orb,:lumo,:lumo,:lumo],int2el[i,lumo:num_orb,a,:lumo])
      x10 =torch.einsum('kecd,je->cdejk',int2el[lumo:num_orb,:lumo,:lumo,:lumo],int2el[lumo:num_orb,i,a,:lumo])
      x11 =torch.einsum('ekcd,je->cdejk',int2el[:lumo,lumo:num_orb,:lumo,:lumo],int2el[i,lumo:num_orb,a,:lumo])
      x12 =torch.einsum('ekcd,je->cdejk',int2el[:lumo,lumo:num_orb,:lumo,:lumo],int2el[lumo:num_orb,i,a,:lumo])
      y1 = -4*x9+2*x10+8*x11-4*x12
      y2 = +8*x9-4*x10-4*x11+2*x12
      e = (noe[a]+noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i]-noe[None,None,None,None,lumo:num_orb])*(noe[None,None,:lumo,None,None]+noe[a]-noe[None,None,None,lumo:num_orb,None]-noe[i])
      ee[a,:,i-lumo,:] += 0.25 * (torch.einsum('cdbk,cdejk->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcbk,cdejk->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))

  for b in range(lumo):
    for i in range(lumo,num_orb):
      x1 =torch.einsum('ecd,jke->cdejk',int2el[i,:lumo,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x2 =torch.einsum('ecd,kje->cdejk',int2el[i,:lumo,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x3 =torch.einsum('ecd,jke->cdejk',int2el[:lumo,i,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      x4 =torch.einsum('ecd,kje->cdejk',int2el[:lumo,i,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
      y1 = +8*x1-4*x2-4*x3+2*x4
      y2 = -4*x1+2*x2+8*x3-4*x4
      e = (noe[b]+noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[None,None,:lumo,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[:,b,i-lumo,:] += 0.5 * (torch.einsum('cdak,cdejk->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcak,cdejk->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    for i in range(lumo,num_orb):
      x9 =torch.einsum('ecd,jke->cdejk',int2el[i,:lumo,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x10 =torch.einsum('ecd,kje->cdejk',int2el[i,:lumo,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x11 =torch.einsum('ecd,jke->cdejk',int2el[:lumo,i,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      x12 =torch.einsum('ecd,kje->cdejk',int2el[:lumo,i,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
      y1 = -4*x9+2*x10+2*x11-4*x12
      y2 = +2*x9-4*x10-4*x11+2*x12
      e = (noe[a]+noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[None,None,:lumo,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[a,:,i-lumo,:] += 0.5 * (torch.einsum('cdbk,cdejk->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcbk,cdejk->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))

  for b in range(lumo):
    for i in range(lumo,num_orb):
      x1 =torch.einsum('kl,jlcd->cdjkl',int2el[i,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x2 =torch.einsum('kl,ljcd->cdjkl',int2el[i,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x3 =torch.einsum('kl,jlcd->cdjkl',int2el[lumo:num_orb,i,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x4 =torch.einsum('kl,ljcd->cdjkl',int2el[lumo:num_orb,i,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      y1 = +4*x1-2*x2-2*x3+4*x4
      y2 = -2*x1+4*x2+4*x3-2*x4
      e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
      ee[:,b,i-lumo,:] += 0.5 * (torch.einsum('cdak,cdjkl->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcak,cdjkl->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    for i in range(lumo,num_orb):
      x9 =torch.einsum('kl,jlcd->cdjkl',int2el[i,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x10 =torch.einsum('kl,ljcd->cdjkl',int2el[i,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x11 =torch.einsum('kl,jlcd->cdjkl',int2el[lumo:num_orb,i,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x12 =torch.einsum('kl,ljcd->cdjkl',int2el[lumo:num_orb,i,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      y1 = -8*x9+4*x10+4*x11-2*x12
      y2 = +4*x9-8*x10-2*x11+4*x12
      e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
      ee[a,:,i-lumo,:] += 0.5 * (torch.einsum('cdbk,cdjkl->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcbk,cdjkl->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))

  for b in range(lumo):
    for i in range(lumo,num_orb):
      x1 =torch.einsum('jl,klcd->cdjkl',int2el[i,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x2 =torch.einsum('jl,lkcd->cdjkl',int2el[i,lumo:num_orb,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x3 =torch.einsum('jl,klcd->cdjkl',int2el[lumo:num_orb,i,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x4 =torch.einsum('jl,lkcd->cdjkl',int2el[lumo:num_orb,i,b,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      y1 = +2*x1-4*x2-4*x3+8*x4
      y2 = -4*x1+2*x2+8*x3-4*x4
      e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[:,b,i-lumo,:] += -0.25 * (torch.einsum('cdak,cdjkl->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcak,cdjkl->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    for i in range(lumo,num_orb):
      x9 =torch.einsum('jl,klcd->cdjkl',int2el[i,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x10 =torch.einsum('jl,lkcd->cdjkl',int2el[i,lumo:num_orb,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x11 =torch.einsum('jl,klcd->cdjkl',int2el[lumo:num_orb,i,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x12 =torch.einsum('jl,lkcd->cdjkl',int2el[lumo:num_orb,i,a,lumo:num_orb],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      y1 = -4*x9+8*x10+2*x11-4*x12
      y2 = +8*x9-4*x10-4*x11+2*x12
      e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[a,:,i-lumo,:] += -0.25 * (torch.einsum('cdbk,cdjkl->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcbk,cdjkl->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))

  for b in range(lumo):
    for i in range(lumo,num_orb):
      x1 =torch.einsum('kec,jde->cdejk',int2el[lumo:num_orb,:lumo,b,:lumo],int2el[i,lumo:num_orb,:lumo,:lumo])
      x2 =torch.einsum('kec,jde->cdejk',int2el[lumo:num_orb,:lumo,b,:lumo],int2el[lumo:num_orb,i,:lumo,:lumo])
      x3 =torch.einsum('ekc,jde->cdejk',int2el[:lumo,lumo:num_orb,b,:lumo],int2el[i,lumo:num_orb,:lumo,:lumo])
      x4 =torch.einsum('ekc,jde->cdejk',int2el[:lumo,lumo:num_orb,b,:lumo],int2el[lumo:num_orb,i,:lumo,:lumo])
      y1 = +2*x1-4*x2-4*x3+2*x4
      y2 = -4*x1+2*x2+8*x3-4*x4
      e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,None,lumo:num_orb,None]-noe[i]-noe[None,None,None,None,lumo:num_orb])*(noe[None,None,:lumo,None,None]+noe[None,:lumo,None,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i])
      ee[:,b,i-lumo,:] += 0.5 * (torch.einsum('cdak,cdejk->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcak,cdejk->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    for i in range(lumo,num_orb):
      x9 =torch.einsum('kec,jde->cdejk',int2el[lumo:num_orb,:lumo,a,:lumo],int2el[i,lumo:num_orb,:lumo,:lumo])
      x10 =torch.einsum('kec,jde->cdejk',int2el[lumo:num_orb,:lumo,a,:lumo],int2el[lumo:num_orb,i,:lumo,:lumo])
      x11 =torch.einsum('ekc,jde->cdejk',int2el[:lumo,lumo:num_orb,a,:lumo],int2el[i,lumo:num_orb,:lumo,:lumo])
      x12 =torch.einsum('ekc,jde->cdejk',int2el[:lumo,lumo:num_orb,a,:lumo],int2el[lumo:num_orb,i,:lumo,:lumo])
      y1 = -4*x9+2*x10+2*x11-4*x12
      y2 = +2*x9-4*x10-4*x11+8*x12
      e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,None,lumo:num_orb,None]-noe[i]-noe[None,None,None,None,lumo:num_orb])*(noe[None,None,:lumo,None,None]+noe[None,:lumo,None,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i])
      ee[a,:,i-lumo,:] += 0.5 * (torch.einsum('cdbk,cdejk->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcbk,cdejk->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))

  for b in range(lumo):
    for i in range(lumo,num_orb):
      x1 =torch.einsum('ec,jkde->cdejk',int2el[i,:lumo,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x2 =torch.einsum('ec,kjde->cdejk',int2el[i,:lumo,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x3 =torch.einsum('ec,jkde->cdejk',int2el[:lumo,i,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x4 =torch.einsum('ec,kjde->cdejk',int2el[:lumo,i,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      y1 = +2*x1-4*x2-4*x3+8*x4
      y2 = -4*x1+2*x2+2*x3-4*x4
      e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[None,None,:lumo,None,None]+noe[None,:lumo,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[:,b,i-lumo,:] += 1.0 * (torch.einsum('cdak,cdejk->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcak,cdejk->aj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))

  for a in range(lumo):
    for i in range(lumo,num_orb):
      x9 =torch.einsum('ec,jkde->cdejk',int2el[i,:lumo,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x10 =torch.einsum('ec,kjde->cdejk',int2el[i,:lumo,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x11 =torch.einsum('ec,jkde->cdejk',int2el[:lumo,i,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      x12 =torch.einsum('ec,kjde->cdejk',int2el[:lumo,i,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
      y1 = -4*x9+8*x10+2*x11-4*x12
      y2 = +8*x9-4*x10-4*x11+2*x12
      e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[None,None,:lumo,None,None]+noe[None,:lumo,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
      ee[a,:,i-lumo,:] += 1.0 * (torch.einsum('cdbk,cdejk->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y1/e)+torch.einsum('dcbk,cdejk->bj',int2el[:lumo,:lumo,:lumo,lumo:num_orb],y2/e))


  # Q
  for a in range(lumo):
    for b in range(lumo):
      for i in range(lumo,num_orb):
        x1 =torch.einsum('kcd,jl->cdjkl',int2el[i,lumo:num_orb,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,b])
        x2 =torch.einsum('kcd,lj->cdjkl',int2el[i,lumo:num_orb,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,b])
        x3 =torch.einsum('kcd,jl->cdjkl',int2el[lumo:num_orb,i,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,b])
        x4 =torch.einsum('kcd,lj->cdjkl',int2el[lumo:num_orb,i,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,b])
        y1 = +2*x1-4*x2-4*x3+8*x4
        y2 = -4*x1+8*x2+2*x3-4*x4
        e = (noe[b]+noe[a]+noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[b]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
        ee[a,b,i-lumo,:] += -0.25 * (torch.einsum('cdkl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('dckl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      for i in range(lumo,num_orb):
        x9 =torch.einsum('kcd,jl->cdjkl',int2el[i,lumo:num_orb,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,a])
        x10 =torch.einsum('kcd,lj->cdjkl',int2el[i,lumo:num_orb,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,a])
        x11 =torch.einsum('kcd,jl->cdjkl',int2el[lumo:num_orb,i,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,a])
        x12 =torch.einsum('kcd,lj->cdjkl',int2el[lumo:num_orb,i,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,a])
        y1 = -4*x9+2*x10+8*x11-4*x12
        y2 = +8*x9-4*x10-4*x11+2*x12
        e = (noe[a]+noe[b]+noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[a]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
        ee[a,b,i-lumo,:] += -0.25 * (torch.einsum('cdkl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('dckl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      for i in range(lumo,num_orb):
        x1 =torch.einsum('jcd,kl->cdjkl',int2el[i,lumo:num_orb,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,b])
        x2 =torch.einsum('jcd,lk->cdjkl',int2el[i,lumo:num_orb,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,b])
        x3 =torch.einsum('jcd,kl->cdjkl',int2el[lumo:num_orb,i,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,b])
        x4 =torch.einsum('jcd,lk->cdjkl',int2el[lumo:num_orb,i,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,b])
        y1 = +4*x1-2*x2-2*x3+4*x4
        y2 = -2*x1+4*x2+4*x3-2*x4
        e = (noe[b]+noe[a]+noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None]-noe[i])*(noe[b]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
        ee[a,b,i-lumo,:] += 0.0625 * (torch.einsum('cdkl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('dckl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      for i in range(lumo,num_orb):
        x9 =torch.einsum('jcd,kl->cdjkl',int2el[i,lumo:num_orb,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,a])
        x10 =torch.einsum('jcd,lk->cdjkl',int2el[i,lumo:num_orb,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,a])
        x11 =torch.einsum('jcd,kl->cdjkl',int2el[lumo:num_orb,i,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,a])
        x12 =torch.einsum('jcd,lk->cdjkl',int2el[lumo:num_orb,i,:lumo,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,a])
        y1 = -2*x9+4*x10+4*x11-2*x12
        y2 = +4*x9-2*x10-2*x11+4*x12
        e = (noe[a]+noe[b]+noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None]-noe[i])*(noe[a]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
        ee[a,b,i-lumo,:] += 0.0625 * (torch.einsum('cdkl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('dckl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      for i in range(lumo,num_orb):
        x1 =torch.einsum('klc,jd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,a,:lumo],int2el[i,lumo:num_orb,b,:lumo])
        x2 =torch.einsum('klc,jd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,a,:lumo],int2el[lumo:num_orb,i,b,:lumo])
        x3 =torch.einsum('lkc,jd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,a,:lumo],int2el[i,lumo:num_orb,b,:lumo])
        x4 =torch.einsum('lkc,jd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,a,:lumo],int2el[lumo:num_orb,i,b,:lumo])
        y1 = +2*x1-4*x2-4*x3+8*x4
        y2 = -4*x1+8*x2+2*x3-4*x4
        e = (noe[None,:lumo,None,None,None]+noe[b]+noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,lumo:num_orb,None,None]-noe[i]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])*(noe[None,:lumo,None,None,None]+noe[b]-noe[None,None,lumo:num_orb,None,None]-noe[i])
        ee[a,b,i-lumo,:] += -0.25 * (torch.einsum('cdkl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('dckl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      for i in range(lumo,num_orb):
        x9 =torch.einsum('klc,jd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,b,:lumo],int2el[i,lumo:num_orb,a,:lumo])
        x10 =torch.einsum('klc,jd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,b,:lumo],int2el[lumo:num_orb,i,a,:lumo])
        x11 =torch.einsum('lkc,jd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,b,:lumo],int2el[i,lumo:num_orb,a,:lumo])
        x12 =torch.einsum('lkc,jd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,b,:lumo],int2el[lumo:num_orb,i,a,:lumo])
        y1 = -4*x9+2*x10+8*x11-4*x12
        y2 = +8*x9-4*x10-4*x11+2*x12
        e = (noe[None,:lumo,None,None,None]+noe[a]+noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,lumo:num_orb,None,None]-noe[i]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])*(noe[None,:lumo,None,None,None]+noe[a]-noe[None,None,lumo:num_orb,None,None]-noe[i])
        ee[a,b,i-lumo,:] += -0.25 * (torch.einsum('cdkl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('dckl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      for i in range(lumo,num_orb):
        x1 =torch.einsum('kc,jld->cdjkl',int2el[i,lumo:num_orb,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
        x2 =torch.einsum('kc,ljd->cdjkl',int2el[i,lumo:num_orb,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
        x3 =torch.einsum('kc,jld->cdjkl',int2el[lumo:num_orb,i,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
        x4 =torch.einsum('kc,ljd->cdjkl',int2el[lumo:num_orb,i,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
        y1 = +16*x1-8*x2-8*x3+4*x4
        y2 = -8*x1+4*x2+4*x3-2*x4
        e = (noe[None,:lumo,None,None,None]+noe[b]+noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
        ee[a,b,i-lumo,:] += 1.0 * (torch.einsum('cdkl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('dckl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      for i in range(lumo,num_orb):
        x9 =torch.einsum('kc,jld->cdjkl',int2el[i,lumo:num_orb,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
        x10 =torch.einsum('kc,ljd->cdjkl',int2el[i,lumo:num_orb,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
        x11 =torch.einsum('kc,jld->cdjkl',int2el[lumo:num_orb,i,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
        x12 =torch.einsum('kc,ljd->cdjkl',int2el[lumo:num_orb,i,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
        y1 = -8*x9+4*x10+4*x11-2*x12
        y2 = +4*x9-2*x10-2*x11+4*x12
        e = (noe[None,:lumo,None,None,None]+noe[a]+noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
        ee[a,b,i-lumo,:] += 1.0 * (torch.einsum('cdkl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('dckl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      for i in range(lumo,num_orb):
        x1 =torch.einsum('jc,kld->cdjkl',int2el[i,lumo:num_orb,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
        x2 =torch.einsum('jc,lkd->cdjkl',int2el[i,lumo:num_orb,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
        x3 =torch.einsum('jc,kld->cdjkl',int2el[lumo:num_orb,i,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
        x4 =torch.einsum('jc,lkd->cdjkl',int2el[lumo:num_orb,i,a,:lumo],int2el[lumo:num_orb,lumo:num_orb,b,:lumo])
        y1 = +8*x1-4*x2-4*x3+2*x4
        y2 = -4*x1+8*x2+2*x3-4*x4
        e = (noe[None,:lumo,None,None,None]+noe[b]+noe[:lumo,None,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
        ee[a,b,i-lumo,:] += -0.25 * (torch.einsum('cdkl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('dckl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      for i in range(lumo,num_orb):
        x9 =torch.einsum('jc,kld->cdjkl',int2el[i,lumo:num_orb,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
        x10 =torch.einsum('jc,lkd->cdjkl',int2el[i,lumo:num_orb,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
        x11 =torch.einsum('jc,kld->cdjkl',int2el[lumo:num_orb,i,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
        x12 =torch.einsum('jc,lkd->cdjkl',int2el[lumo:num_orb,i,b,:lumo],int2el[lumo:num_orb,lumo:num_orb,a,:lumo])
        y1 = -4*x9+2*x10+8*x11-4*x12
        y2 = +2*x9-4*x10-4*x11+8*x12
        e = (noe[None,:lumo,None,None,None]+noe[a]+noe[:lumo,None,None,None,None]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None]-noe[None,None,lumo:num_orb,None,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])
        ee[a,b,i-lumo,:] += -0.25 * (torch.einsum('cdkl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('dckl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      for i in range(lumo,num_orb):
        x1 =torch.einsum('kl,jcd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,a,b],int2el[i,lumo:num_orb,:lumo,:lumo])
        x2 =torch.einsum('kl,jcd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,a,b],int2el[lumo:num_orb,i,:lumo,:lumo])
        x3 =torch.einsum('lk,jcd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,a,b],int2el[i,lumo:num_orb,:lumo,:lumo])
        x4 =torch.einsum('lk,jcd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,a,b],int2el[lumo:num_orb,i,:lumo,:lumo])
        y1 = +4*x1-2*x2-2*x3+4*x4
        y2 = -2*x1+4*x2+4*x3-2*x4
        e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]+noe[b]+noe[a]-noe[None,None,lumo:num_orb,None,None]-noe[i]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,lumo:num_orb,None,None]-noe[i])
        ee[a,b,i-lumo,:] += 0.0625 * (torch.einsum('cdkl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('dckl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      for i in range(lumo,num_orb):
        x9 =torch.einsum('kl,jcd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,b,a],int2el[i,lumo:num_orb,:lumo,:lumo])
        x10 =torch.einsum('kl,jcd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,b,a],int2el[lumo:num_orb,i,:lumo,:lumo])
        x11 =torch.einsum('lk,jcd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,b,a],int2el[i,lumo:num_orb,:lumo,:lumo])
        x12 =torch.einsum('lk,jcd->cdjkl',int2el[lumo:num_orb,lumo:num_orb,b,a],int2el[lumo:num_orb,i,:lumo,:lumo])
        y1 = -2*x9+4*x10+4*x11-2*x12
        y2 = +4*x9-2*x10-2*x11+4*x12
        e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]+noe[a]+noe[b]-noe[None,None,lumo:num_orb,None,None]-noe[i]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,None,lumo:num_orb,None])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,lumo:num_orb,None,None]-noe[i])
        ee[a,b,i-lumo,:] += 0.0625 * (torch.einsum('cdkl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('dckl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      for i in range(lumo,num_orb):
        x1 =torch.einsum('k,jlcd->cdjkl',int2el[i,lumo:num_orb,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
        x2 =torch.einsum('k,ljcd->cdjkl',int2el[i,lumo:num_orb,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
        x3 =torch.einsum('k,jlcd->cdjkl',int2el[lumo:num_orb,i,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
        x4 =torch.einsum('k,ljcd->cdjkl',int2el[lumo:num_orb,i,a,b],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
        y1 = +8*x1-4*x2-4*x3+2*x4
        y2 = -4*x1+8*x2+2*x3-4*x4
        e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]+noe[b]+noe[a]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
        ee[a,b,i-lumo,:] += -0.25 * (torch.einsum('cdkl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('dckl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y2/e))

  for a in range(lumo):
    for b in range(lumo):
      for i in range(lumo,num_orb):
        x9 =torch.einsum('k,jlcd->cdjkl',int2el[i,lumo:num_orb,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
        x10 =torch.einsum('k,ljcd->cdjkl',int2el[i,lumo:num_orb,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
        x11 =torch.einsum('k,jlcd->cdjkl',int2el[lumo:num_orb,i,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
        x12 =torch.einsum('k,ljcd->cdjkl',int2el[lumo:num_orb,i,b,a],int2el[lumo:num_orb,lumo:num_orb,:lumo,:lumo])
        y1 = -4*x9+2*x10+8*x11-4*x12
        y2 = +2*x9-4*x10-4*x11+8*x12
        e = (noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]+noe[a]+noe[b]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None]-noe[None,None,None,lumo:num_orb,None]-noe[i])*(noe[None,:lumo,None,None,None]+noe[:lumo,None,None,None,None]-noe[None,None,None,None,lumo:num_orb]-noe[None,None,lumo:num_orb,None,None])
        ee[a,b,i-lumo,:] += -0.25 * (torch.einsum('cdkl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y1/e)+torch.einsum('dckl,cdjkl->j',int2el[:lumo,:lumo,lumo:num_orb,lumo:num_orb],y2/e))
  
  for i in range(lumo,num_orb):
    for j in range(lumo,num_orb):
      for a in range(lumo):
        for b in range(lumo):
          e1 = e1 + ee[a,b,i-lumo,j-lumo]*int2el[a,b,i,j]/(noe[a]+noe[b]-noe[i]-noe[j])

  #amp = ee/(noe[a,None,None,None]+noe[None,b,None,None]-noe[None,None,i,None]-noe[None,None,None,j])
  amp = ee/(noe[:lumo,None,None,None]+noe[None,:lumo,None,None]-noe[None,None,lumo:num_orb,None]-noe[None,None,None,lumo:num_orb])

  return e1.numpy(), amp.numpy()


def main():  
  fwfn = sys.argv[1]
  ffci = sys.argv[2]
    
  # load orbital information
  with h5py.File(fwfn, 'r') as hf:
    typ_orb, num_orb, num_prt, num_nuc = hf['BASIC'][:]
    noon = hf['NOON'][:]
    noe = hf['NOE'][:]

  # load 2-ele terms
  int2el = np.load(ffci)

  # check lumo
  lumo = int(round(np.sum(noon)/2))
  if lumo == num_orb:
    print("Fully occupied, no need for MP4")
  if num_orb > len(int2el):
    print("FCIDUMP only has " + str(len(int2el)) + " orbitals, while WFN gives " + str(num_orb) + " orbitals, use FCIDUMP instead")
    num_orb = len(int2el)

  # calculate MP4 energy
  t1 = time.time()
  torch.set_num_threads(8)
  device = torch.device("cpu")
  int2el =torch.tensor(int2el, device=device).float()
  noe =torch.tensor(noe, device=device).float()

  emp4, amp = calcu_mp4(num_orb, lumo, noe, int2el, device)
  #print(time.time()-t1)
  #print(emp4)
          
  np.save('mp4_amp.npy', amp)

if __name__ == "__main__":
  main()
