import numpy as np
import sys
import os
import re
import h5py

def ene(lines):
  pattern = r'Ene=(.*)'
  noe = re.findall(pattern, lines, re.MULTILINE)
  noe = np.array([float(e.strip()) for e in noe])

  return noe

name_hf = sys.argv[1]
name_e = sys.argv[2]

typ_orb = 0

with open(name_e, 'r') as f:
  noe = ene(f.read())
  print(noe)

# modify hdf5 file
with h5py.File(name_hf, 'r+') as hf:
  data = hf['NOE']
  _, num_orb, _, _ = hf['BASIC'][:] 
  if num_orb < len(noe):
    print('molden file has ' + str(len(noe)) + ' orbitals, but wfn file only has ' + str(num_orb) + ' orbitals, use only ' + str(num_orb) + '.')
    noe = noe[:num_orb]
  data[...] = noe


